#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

void fail(char * message)
{
  fprintf(stderr, message);
  abort();
}

int spawn (char * program, char ** arg_list)
{
  pid_t child_pid;

  if (child_pid = fork())
      return child_pid;
  else 
    {
      execvp(program, arg_list);
      /* execvp returns only upon error */
      fail("error in execvp");
    }
}

int main()
{
  int child_pid, status;
  
  char * arg_list[] = {
    "ls", /* argv[0] is the name of the program */
    "-l",
    ".",
    NULL
  };
  
  puts("Begins directory listing for .");
  child_pid = spawn("ls", arg_list);

  puts("Waiting for child process to end...");
  if (waitpid(child_pid, &status, 0) == child_pid)
    printf("Child process terminated.\n"
	   "Normal termnination = %i\n"
	   "Exit code           = %i\n",
	   WIFEXITED(status), WEXITSTATUS(status));      
  else 
    fail("error in waitpid");
  return 0;
}
