#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>


typedef int work_func(void * parameterp);


void fail(char * message)
{
  fprintf(stderr, message);
  abort();
}

int proc(void * parameterp)
{
  int i;
  for (i=0; i<10; i++){
    printf("This is process %s.\n", (char*) parameterp);
    sleep(1);
  }
  return 123;
}

int start(work_func * functionp, void * parameterp)
{
  pid_t child_pid;
  
  if (child_pid = fork())
    {
      puts("Successfully started");
      return child_pid;
    }
  else 
    {
      printf("Starting process %s.\n", parameterp);      
      exit(functionp(parameterp));
    }
}

int main()
{
  int child1_pid, child2_pid, pid, status, i;
    
  child1_pid = start(&proc, "1");
  usleep(500000); // wait half second
  child2_pid = start(&proc, "2");

  puts("Waiting for first child process to end...");
  
  for (i=0; i<2; i++)
    {
      pid = wait(&status);  
      printf("Child process [PID %i] terminated." 
	     "Normal termination = %i. Exit code = %i.\n", 
	     pid, WIFEXITED(status), WEXITSTATUS(status));
    }  
  
  return 0;
}
